<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>CCodeRefactoring: StmtProcDispatcher.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
  $(document).ready(function() { init_search(); });
/* @license-end */
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">CCodeRefactoring
   &#160;<span id="projectnumber">First Alpha</span>
   </div>
   <div id="projectbrief">Create Simulation Executable From Existing Code</div>
  </td>
   <td>        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
</td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('_stmt_proc_dispatcher_8h_source.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">StmtProcDispatcher.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_stmt_proc_dispatcher_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160; </div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160; </div>
<div class="line"><a name="l00003"></a><span class="lineno"><a class="line" href="_stmt_proc_dispatcher_8h.html#a89adee888d6cc38fc2aea0ca806daf26">    3</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="_stmt_proc_dispatcher_8h.html#a89adee888d6cc38fc2aea0ca806daf26">dispatchStmtProc</a>(bsoncxx::builder::basic::document&amp; MainNode,<a class="code" href="struct_sub_level_properties.html">SubLevelProperties</a> &amp;SubLvlPrp,<a class="code" href="struct_binary_op_properties.html">BinaryOpProperties</a> &amp;BinOpProp,<span class="keyword">const</span> SourceManager &amp;SourceManager,Stmt::const_child_iterator ir)</div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;{</div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;    <span class="keywordtype">bool</span> match = <span class="keyword">false</span>;</div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;    <span class="comment">//Expression</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;    <span class="comment">//see EXPR-&gt;getStmtClassName() to find the name of the expression behind the generic EXPR or STMT</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;    <span class="keyword">const</span> Expr *EXPR = dyn_cast&lt;Expr&gt;(*ir);</div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;    <span class="keywordflow">if</span>(EXPR)    { </div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;    </div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;        <span class="comment">//DeclRefExpr</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;        <span class="keyword">const</span> DeclRefExpr *DR = dyn_cast&lt;DeclRefExpr&gt;(*ir);</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;        <span class="keywordflow">if</span>(DR) { <a class="code" href="_decl_ref_expr_proc_8h.html#a0a2ab7ebf84ec2c05077ee68fc8e132c">DeclRefExprProc</a>(MainNode,SubLvlPrp,BinOpProp,DR,SourceManager); match = <span class="keyword">true</span>;}</div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;        <span class="comment">//CastExpr</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;        <span class="keyword">const</span> CastExpr *IC = dyn_cast&lt;CastExpr&gt;(*ir); </div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;        <span class="keywordflow">if</span>(IC)</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;        { <a class="code" href="_decl_ref_expr_proc_8h.html#a0fc130806db0baa658969dbbd9a76566">CastExprProc</a>(MainNode,SubLvlPrp,BinOpProp,IC,SourceManager); match = <span class="keyword">true</span>;}</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;        <span class="comment">// CallExpr</span></div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;        <span class="keyword">const</span> CallExpr *CE = dyn_cast&lt;CallExpr&gt;(*ir);</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;        <span class="keywordflow">if</span>(CE) </div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;        { <a class="code" href="_decl_ref_expr_proc_8h.html#affd6655ecb67077219b58596d238e794">CallExprProc</a>(MainNode,SubLvlPrp,BinOpProp,CE,SourceManager); match = <span class="keyword">true</span>;} </div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;        <span class="comment">// IntegerLiteral</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;        <span class="keyword">const</span> IntegerLiteral *IL = dyn_cast&lt;IntegerLiteral&gt;(*ir);</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;        <span class="keywordflow">if</span>(IL)</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;        { <a class="code" href="_decl_ref_expr_proc_8h.html#a78917b982a9452c0cafed9b51491bd51">IntegerLiteralProc</a>(MainNode,SubLvlPrp,BinOpProp,IL,SourceManager); match = <span class="keyword">true</span>;}</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;        <span class="comment">// FloatingLiteral</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;        <span class="keyword">const</span> FloatingLiteral *FloatLitS = dyn_cast&lt;FloatingLiteral&gt;(*ir);</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;        <span class="keywordflow">if</span>(FloatLitS)</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;        { <a class="code" href="_decl_ref_expr_proc_8h.html#ac4e74b9a8ec63c90b5b76b9bd385b2f9">FloatLiteralProc</a>(MainNode,SubLvlPrp,BinOpProp,FloatLitS,SourceManager); match = <span class="keyword">true</span>;}                                    </div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;        <span class="comment">// StringLiteral</span></div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;        <span class="keyword">const</span> clang::StringLiteral *StrLitS = dyn_cast&lt;clang::StringLiteral&gt;(*ir);</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;        <span class="keywordflow">if</span>(StrLitS)</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;        { <a class="code" href="_decl_ref_expr_proc_8h.html#a8132564d2d13a6f01fb970b6daee16d6">StringLiteralProc</a>(MainNode,SubLvlPrp,BinOpProp,StrLitS,SourceManager); match = <span class="keyword">true</span>;}</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;        <span class="comment">// CharacterLiteral</span></div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;        <span class="keyword">const</span> CharacterLiteral *CharLitS = dyn_cast&lt;CharacterLiteral&gt;(*ir);</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;        <span class="keywordflow">if</span>(CharLitS)</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;        { <a class="code" href="_decl_ref_expr_proc_8h.html#a525fc8516c619ae83939e43b328ddc41">CharacterLiteralProc</a>(MainNode,SubLvlPrp,BinOpProp,CharLitS,SourceManager); match = <span class="keyword">true</span>;}</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;        <span class="comment">// CompoundLiteral</span></div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;        <span class="keyword">const</span> CompoundLiteralExpr *CompLitS = dyn_cast&lt;CompoundLiteralExpr&gt;(*ir);</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;        <span class="keywordflow">if</span>(CompLitS)</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;        { <a class="code" href="_decl_ref_expr_proc_8h.html#aa3fbe79687b97727408239ea329424b8">CompoundLiteralProc</a>(MainNode,SubLvlPrp,BinOpProp,CompLitS,SourceManager); match = <span class="keyword">true</span>;}</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;        <span class="comment">// BinaryOperator</span></div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;        <span class="keyword">const</span> BinaryOperator *BO = dyn_cast&lt;BinaryOperator&gt;(*ir);</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;        <span class="keywordflow">if</span>(BO)</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;        { <a class="code" href="_decl_ref_expr_proc_8h.html#a17e632ef425d71c14e55c2e5f11eb827">BinaryOperatorProc</a>(MainNode,SubLvlPrp,BO,BinOpProp,SourceManager); match = <span class="keyword">true</span>;}</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160; </div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;        <span class="comment">// Parenthesis</span></div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;        <span class="keyword">const</span> ParenExpr *PE = dyn_cast&lt;ParenExpr&gt;(*ir);</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;        <span class="keywordflow">if</span>(PE)</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;        { <a class="code" href="_decl_ref_expr_proc_8h.html#ade8fb9ab0f90e12ab48ddb14d55de5ee">ParenthesisExprProc</a>(MainNode,SubLvlPrp,PE,SourceManager,BinOpProp); match = <span class="keyword">true</span>;}</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160; </div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;        <span class="comment">// UnaryOperator</span></div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;        <span class="keyword">const</span> UnaryOperator *UO = dyn_cast&lt;UnaryOperator&gt;(*ir);</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;        <span class="keywordflow">if</span>(UO)</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;        { <a class="code" href="_decl_ref_expr_proc_8h.html#a59544ecbac44a5f40490d9eeac1722ed">UnaryOperatorProc</a>(MainNode,SubLvlPrp,UO,SourceManager,BinOpProp); match = <span class="keyword">true</span>;}</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;        <span class="comment">// MemberEpxr</span></div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;        <span class="keyword">const</span> MemberExpr *ME = dyn_cast&lt;MemberExpr&gt;(*ir);</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;        <span class="keywordflow">if</span>(ME)</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;        { <a class="code" href="_decl_ref_expr_proc_8h.html#a9c91ca84f5245f7e0359cda6c2b893d7">MemberExprProc</a>(MainNode,SubLvlPrp,BinOpProp,ME,SourceManager); match = <span class="keyword">true</span>;}</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;        <span class="comment">// ArraySubscriptExpr</span></div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;        <span class="keyword">const</span> ArraySubscriptExpr *ArraySubsS = dyn_cast&lt;ArraySubscriptExpr&gt;(*ir);</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;        <span class="keywordflow">if</span>(ArraySubsS)</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;        { match = <span class="keyword">true</span>;</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;          <a class="code" href="_decl_ref_expr_proc_8h.html#a8e8b2b4325c9b4e6b43b31efb0c9f2b9">UnknownStmtORExprProc</a>(MainNode,SubLvlPrp,BinOpProp,ArraySubsS,SourceManager);         </div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;        } </div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;        <span class="keyword">const</span> clang::ConditionalOperator *CONDOP = dyn_cast&lt;ConditionalOperator&gt;(*ir);</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;        <span class="keywordflow">if</span>(CONDOP) {</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;        match = <span class="keyword">true</span>;</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;            <a class="code" href="_decl_ref_expr_proc_8h.html#a8e8b2b4325c9b4e6b43b31efb0c9f2b9">UnknownStmtORExprProc</a>(MainNode,SubLvlPrp,BinOpProp,CONDOP,SourceManager);       </div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;        }</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160; </div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;        <span class="comment">// This is a statement expression</span></div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;        <span class="comment">// ({                                                          \</span></div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;<span class="comment">        //    typeof(x_s32) _x=(x_s32);                               \</span></div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;<span class="comment">        //    typeof(y_s32) _y=(y_s32);                               \</span></div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;<span class="comment">        //    (((_y) &gt; (_x)) ? (_x) : (_y));                          \</span></div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;<span class="comment">        //})</span></div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;        <span class="keyword">const</span> clang::StmtExpr *STMTEXPR = dyn_cast&lt;StmtExpr&gt;(*ir);</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;        <span class="keywordflow">if</span>(STMTEXPR)</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;         {</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;            match = <span class="keyword">true</span>;</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;         }</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;        <span class="keywordflow">if</span>(!match)</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;          {</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;            <a class="code" href="_decl_ref_expr_proc_8h.html#a8e8b2b4325c9b4e6b43b31efb0c9f2b9">UnknownStmtORExprProc</a>(MainNode,SubLvlPrp,BinOpProp,EXPR,SourceManager); </div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;          }</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;        }</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;    <span class="keywordflow">else</span></div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;    {</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;    <span class="keyword">const</span> clang::DeclStmt *DECLS = dyn_cast&lt;DeclStmt&gt;(*ir);</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    <span class="keywordflow">if</span>(DECLS)</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;            {</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;            match = <span class="keyword">true</span>;</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;            <a class="code" href="_decl_ref_expr_proc_8h.html#aa46acd7e90d1797e3eb0ce791ee48f61">DeclsProc</a>(MainNode,BinOpProp,DECLS,SourceManager); </div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;            }</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;    <span class="keyword">const</span> clang::IfStmt *IFS = dyn_cast&lt;IfStmt&gt;(*ir);</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    <span class="keywordflow">if</span>(IFS)     { </div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;            match = <span class="keyword">true</span>;</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;            <a class="code" href="_decl_ref_expr_proc_8h.html#ab01c0bf06445c519cf834713fef5d47f">IfStmtProc</a>(MainNode,SubLvlPrp,BinOpProp,IFS,SourceManager);</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;            </div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;            }</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;    <span class="keyword">const</span> clang::WhileStmt *WHLS = dyn_cast&lt;WhileStmt&gt;(*ir);</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;    <span class="keywordflow">if</span>(WHLS)    {</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;            match = <span class="keyword">true</span>; </div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;            <a class="code" href="_decl_ref_expr_proc_8h.html#a3ac3e261297050d743bc39b4f4f465e2">WhileStmtProc</a>(MainNode,SubLvlPrp,BinOpProp,WHLS,SourceManager);</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;            }</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;    <span class="keyword">const</span> clang::DoStmt *DOS = dyn_cast&lt;DoStmt&gt;(*ir);</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;    <span class="keywordflow">if</span>(DOS) { </div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;            match = <span class="keyword">true</span>;</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;            <a class="code" href="_decl_ref_expr_proc_8h.html#aedc421d4d843891d1c5fa6f349f78819">DoStmtProc</a>(MainNode,SubLvlPrp,BinOpProp,DOS,SourceManager);</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;            }</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;    <span class="keyword">const</span> clang::ForStmt *FOR = dyn_cast&lt;ForStmt&gt;(*ir);</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;    <span class="keywordflow">if</span>(FOR) { </div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;            match = <span class="keyword">true</span>;</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;            <a class="code" href="_decl_ref_expr_proc_8h.html#a7aa8f645e442887c3cb75e4185d6c922">ForStmtProc</a>(MainNode,SubLvlPrp,BinOpProp,FOR,SourceManager);</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;        }</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;    <span class="keyword">const</span> clang::SwitchStmt *SWTCHS = dyn_cast&lt;SwitchStmt&gt;(*ir);</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;    <span class="keywordflow">if</span>(SWTCHS)  { </div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;            match = <span class="keyword">true</span>;</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;            <a class="code" href="_decl_ref_expr_proc_8h.html#a32c73a67da80dca716c3f23936948eb5">SwitchStmtProc</a>(MainNode,SubLvlPrp,BinOpProp,SWTCHS,SourceManager);</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;            }</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160; </div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;    <span class="keyword">const</span> clang::SwitchCase *SWTCHCAS = dyn_cast&lt;SwitchCase&gt;(*ir);</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;    <span class="keywordflow">if</span>(SWTCHCAS)    {</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;            match = <span class="keyword">true</span>; </div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;            <a class="code" href="_decl_ref_expr_proc_8h.html#ab8638bfd78071da2476e12f2be8de2c2">SWCaseStmtProc</a>(MainNode,SubLvlPrp,BinOpProp,SWTCHCAS,SourceManager);</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;            }</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;    <span class="keyword">const</span> clang::BreakStmt *BRKSTMT = dyn_cast&lt;BreakStmt&gt;(*ir);</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;    <span class="keywordflow">if</span>(BRKSTMT) {</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;            match = <span class="keyword">true</span>; </div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;            <a class="code" href="_decl_ref_expr_proc_8h.html#a8e8b2b4325c9b4e6b43b31efb0c9f2b9">UnknownStmtORExprProc</a>(MainNode,SubLvlPrp,BinOpProp,BRKSTMT,SourceManager); </div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;            }</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;    <span class="keyword">const</span> clang::CompoundStmt *CMPSTMT = dyn_cast&lt;CompoundStmt&gt;(*ir);</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;    <span class="keywordflow">if</span>(CMPSTMT) {</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;            match = <span class="keyword">true</span>; </div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;            <a class="code" href="_decl_ref_expr_proc_8h.html#a8e8b2b4325c9b4e6b43b31efb0c9f2b9">UnknownStmtORExprProc</a>(MainNode,SubLvlPrp,BinOpProp,CMPSTMT,SourceManager); </div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;            }</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160; </div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160; </div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;        <span class="keywordflow">if</span>(!match)</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;          {</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;            <span class="keyword">const</span> clang::Stmt *STMT = dyn_cast&lt;Stmt&gt;(*ir);</div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;            <a class="code" href="_decl_ref_expr_proc_8h.html#a8e8b2b4325c9b4e6b43b31efb0c9f2b9">UnknownStmtORExprProc</a>(MainNode,SubLvlPrp,BinOpProp,STMT,SourceManager);  </div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;          }</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;    }</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160; <span class="keywordflow">return</span>;</div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;}</div>
<div class="line"><a name="l00148"></a><span class="lineno"><a class="line" href="_stmt_proc_dispatcher_8h.html#ae364a6155195062d852e4839fa36732a">  148</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="_stmt_proc_dispatcher_8h.html#ae364a6155195062d852e4839fa36732a">TopLevlStmtProc</a>(bsoncxx::builder::basic::document&amp; MainNode,<a class="code" href="struct_binary_op_properties.html">BinaryOpProperties</a> &amp;BinOpProp,<span class="keyword">const</span> SourceManager &amp;SourceManager,<span class="keyword">const</span> clang::CompoundStmt *CMPND)</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;{</div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;    <span class="keywordflow">if</span>(CMPND)   </div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;    { </div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;        <a class="code" href="_decl_ref_expr_proc_8h.html#a5af644c608ba02b5c6c6dfc2d67a13b7">CmpndProc</a>(MainNode,BinOpProp,CMPND,SourceManager);</div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;    }</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;}</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160; </div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160; </div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<div class="ttc" id="a_decl_ref_expr_proc_8h_html_a525fc8516c619ae83939e43b328ddc41"><div class="ttname"><a href="_decl_ref_expr_proc_8h.html#a525fc8516c619ae83939e43b328ddc41">CharacterLiteralProc</a></div><div class="ttdeci">void CharacterLiteralProc(bsoncxx::builder::basic::document &amp;MainNode, SubLevelProperties &amp;SubLvlPrp, BinaryOpProperties &amp;BinOpProp, const CharacterLiteral *CL, const SourceManager &amp;SourceManager)</div><div class="ttdef"><b>Definition:</b> DeclRefExprProc.h:697</div></div>
<div class="ttc" id="a_stmt_proc_dispatcher_8h_html_ae364a6155195062d852e4839fa36732a"><div class="ttname"><a href="_stmt_proc_dispatcher_8h.html#ae364a6155195062d852e4839fa36732a">TopLevlStmtProc</a></div><div class="ttdeci">void TopLevlStmtProc(bsoncxx::builder::basic::document &amp;MainNode, BinaryOpProperties &amp;BinOpProp, const SourceManager &amp;SourceManager, const clang::CompoundStmt *CMPND)</div><div class="ttdef"><b>Definition:</b> StmtProcDispatcher.h:148</div></div>
<div class="ttc" id="a_decl_ref_expr_proc_8h_html_affd6655ecb67077219b58596d238e794"><div class="ttname"><a href="_decl_ref_expr_proc_8h.html#affd6655ecb67077219b58596d238e794">CallExprProc</a></div><div class="ttdeci">void CallExprProc(bsoncxx::builder::basic::document &amp;MainNode, SubLevelProperties &amp;SubLvlPrp, BinaryOpProperties &amp;BinOpProp, const CallExpr *CE, const SourceManager &amp;SourceManager)</div><div class="ttdef"><b>Definition:</b> DeclRefExprProc.h:606</div></div>
<div class="ttc" id="a_stmt_proc_dispatcher_8h_html_a89adee888d6cc38fc2aea0ca806daf26"><div class="ttname"><a href="_stmt_proc_dispatcher_8h.html#a89adee888d6cc38fc2aea0ca806daf26">dispatchStmtProc</a></div><div class="ttdeci">void dispatchStmtProc(bsoncxx::builder::basic::document &amp;MainNode, SubLevelProperties &amp;SubLvlPrp, BinaryOpProperties &amp;BinOpProp, const SourceManager &amp;SourceManager, Stmt::const_child_iterator ir)</div><div class="ttdef"><b>Definition:</b> StmtProcDispatcher.h:3</div></div>
<div class="ttc" id="a_decl_ref_expr_proc_8h_html_a78917b982a9452c0cafed9b51491bd51"><div class="ttname"><a href="_decl_ref_expr_proc_8h.html#a78917b982a9452c0cafed9b51491bd51">IntegerLiteralProc</a></div><div class="ttdeci">void IntegerLiteralProc(bsoncxx::builder::basic::document &amp;MainNode, SubLevelProperties &amp;SubLvlPrp, BinaryOpProperties &amp;BinOpProp, const IntegerLiteral *IL, const SourceManager &amp;SourceManager)</div><div class="ttdef"><b>Definition:</b> DeclRefExprProc.h:649</div></div>
<div class="ttc" id="a_decl_ref_expr_proc_8h_html_a17e632ef425d71c14e55c2e5f11eb827"><div class="ttname"><a href="_decl_ref_expr_proc_8h.html#a17e632ef425d71c14e55c2e5f11eb827">BinaryOperatorProc</a></div><div class="ttdeci">void BinaryOperatorProc(bsoncxx::builder::basic::document &amp;MainNode, SubLevelProperties &amp;SubLvlPrp, const BinaryOperator *BO, BinaryOpProperties &amp;BinOpProp, const SourceManager &amp;SourceManager)</div><div class="ttdef"><b>Definition:</b> DeclRefExprProc.h:717</div></div>
<div class="ttc" id="a_decl_ref_expr_proc_8h_html_aa46acd7e90d1797e3eb0ce791ee48f61"><div class="ttname"><a href="_decl_ref_expr_proc_8h.html#aa46acd7e90d1797e3eb0ce791ee48f61">DeclsProc</a></div><div class="ttdeci">void DeclsProc(bsoncxx::builder::basic::document &amp;MainNode, BinaryOpProperties &amp;BinOpProp, const clang::DeclStmt *DCLS, const SourceManager &amp;SourceManager)</div><div class="ttdef"><b>Definition:</b> DeclRefExprProc.h:955</div></div>
<div class="ttc" id="a_decl_ref_expr_proc_8h_html_aedc421d4d843891d1c5fa6f349f78819"><div class="ttname"><a href="_decl_ref_expr_proc_8h.html#aedc421d4d843891d1c5fa6f349f78819">DoStmtProc</a></div><div class="ttdeci">void DoStmtProc(bsoncxx::builder::basic::document &amp;MainNode, SubLevelProperties &amp;SubLvlPrp, BinaryOpProperties &amp;BinOpProp, const clang::DoStmt *DOS, const SourceManager &amp;SourceManager)</div><div class="ttdef"><b>Definition:</b> DeclRefExprProc.h:823</div></div>
<div class="ttc" id="a_decl_ref_expr_proc_8h_html_a8e8b2b4325c9b4e6b43b31efb0c9f2b9"><div class="ttname"><a href="_decl_ref_expr_proc_8h.html#a8e8b2b4325c9b4e6b43b31efb0c9f2b9">UnknownStmtORExprProc</a></div><div class="ttdeci">void UnknownStmtORExprProc(bsoncxx::builder::basic::document &amp;MainNode, SubLevelProperties &amp;SubLvlPrp, BinaryOpProperties &amp;BinOpProp, const clang::Stmt *STMT, const SourceManager &amp;SourceManager)</div><div class="ttdef"><b>Definition:</b> DeclRefExprProc.h:637</div></div>
<div class="ttc" id="a_decl_ref_expr_proc_8h_html_a0fc130806db0baa658969dbbd9a76566"><div class="ttname"><a href="_decl_ref_expr_proc_8h.html#a0fc130806db0baa658969dbbd9a76566">CastExprProc</a></div><div class="ttdeci">void CastExprProc(bsoncxx::builder::basic::document &amp;MainNode, SubLevelProperties &amp;SubLvlPrp, BinaryOpProperties &amp;BinOpProp, const CastExpr *IC, const SourceManager &amp;SourceManager)</div><div class="ttdef"><b>Definition:</b> DeclRefExprProc.h:568</div></div>
<div class="ttc" id="a_decl_ref_expr_proc_8h_html_a59544ecbac44a5f40490d9eeac1722ed"><div class="ttname"><a href="_decl_ref_expr_proc_8h.html#a59544ecbac44a5f40490d9eeac1722ed">UnaryOperatorProc</a></div><div class="ttdeci">void UnaryOperatorProc(bsoncxx::builder::basic::document &amp;MainNode, SubLevelProperties &amp;SubLvlPrp, const UnaryOperator *UO, const SourceManager &amp;SourceManager, BinaryOpProperties &amp;BinOpProp)</div><div class="ttdef"><b>Definition:</b> DeclRefExprProc.h:740</div></div>
<div class="ttc" id="astruct_sub_level_properties_html"><div class="ttname"><a href="struct_sub_level_properties.html">SubLevelProperties</a></div><div class="ttdef"><b>Definition:</b> TypesForAnalysis.h:544</div></div>
<div class="ttc" id="a_decl_ref_expr_proc_8h_html_ab01c0bf06445c519cf834713fef5d47f"><div class="ttname"><a href="_decl_ref_expr_proc_8h.html#ab01c0bf06445c519cf834713fef5d47f">IfStmtProc</a></div><div class="ttdeci">void IfStmtProc(bsoncxx::builder::basic::document &amp;MainNode, SubLevelProperties &amp;SubLvlPrp, BinaryOpProperties &amp;BinOpProp, const clang::IfStmt *IFS, const SourceManager &amp;SourceManager)</div><div class="ttdef"><b>Definition:</b> DeclRefExprProc.h:773</div></div>
<div class="ttc" id="a_decl_ref_expr_proc_8h_html_aa3fbe79687b97727408239ea329424b8"><div class="ttname"><a href="_decl_ref_expr_proc_8h.html#aa3fbe79687b97727408239ea329424b8">CompoundLiteralProc</a></div><div class="ttdeci">void CompoundLiteralProc(bsoncxx::builder::basic::document &amp;MainNode, SubLevelProperties &amp;SubLvlPrp, BinaryOpProperties &amp;BinOpProp, const CompoundLiteralExpr *CMPL, const SourceManager &amp;SourceManager)</div><div class="ttdef"><b>Definition:</b> DeclRefExprProc.h:707</div></div>
<div class="ttc" id="a_decl_ref_expr_proc_8h_html_a8132564d2d13a6f01fb970b6daee16d6"><div class="ttname"><a href="_decl_ref_expr_proc_8h.html#a8132564d2d13a6f01fb970b6daee16d6">StringLiteralProc</a></div><div class="ttdeci">void StringLiteralProc(bsoncxx::builder::basic::document &amp;MainNode, SubLevelProperties &amp;SubLvlPrp, BinaryOpProperties &amp;BinOpProp, const clang::StringLiteral *SL, const SourceManager &amp;SourceManager)</div><div class="ttdef"><b>Definition:</b> DeclRefExprProc.h:687</div></div>
<div class="ttc" id="a_decl_ref_expr_proc_8h_html_a5af644c608ba02b5c6c6dfc2d67a13b7"><div class="ttname"><a href="_decl_ref_expr_proc_8h.html#a5af644c608ba02b5c6c6dfc2d67a13b7">CmpndProc</a></div><div class="ttdeci">void CmpndProc(bsoncxx::builder::basic::document &amp;MainNode, BinaryOpProperties &amp;BinOpProp, const clang::CompoundStmt *CMPND, const SourceManager &amp;SourceManager)</div><div class="ttdef"><b>Definition:</b> DeclRefExprProc.h:993</div></div>
<div class="ttc" id="a_decl_ref_expr_proc_8h_html_ab8638bfd78071da2476e12f2be8de2c2"><div class="ttname"><a href="_decl_ref_expr_proc_8h.html#ab8638bfd78071da2476e12f2be8de2c2">SWCaseStmtProc</a></div><div class="ttdeci">void SWCaseStmtProc(bsoncxx::builder::basic::document &amp;MainNode, SubLevelProperties &amp;SubLvlPrp, BinaryOpProperties &amp;BinOpProp, const clang::SwitchCase *SWTCHCAS, const SourceManager &amp;SourceManager)</div><div class="ttdef"><b>Definition:</b> DeclRefExprProc.h:936</div></div>
<div class="ttc" id="a_decl_ref_expr_proc_8h_html_a7aa8f645e442887c3cb75e4185d6c922"><div class="ttname"><a href="_decl_ref_expr_proc_8h.html#a7aa8f645e442887c3cb75e4185d6c922">ForStmtProc</a></div><div class="ttdeci">void ForStmtProc(bsoncxx::builder::basic::document &amp;MainNode, SubLevelProperties &amp;SubLvlPrp, BinaryOpProperties &amp;BinOpProp, const clang::ForStmt *FOR, const SourceManager &amp;SourceManager)</div><div class="ttdef"><b>Definition:</b> DeclRefExprProc.h:845</div></div>
<div class="ttc" id="a_decl_ref_expr_proc_8h_html_a0a2ab7ebf84ec2c05077ee68fc8e132c"><div class="ttname"><a href="_decl_ref_expr_proc_8h.html#a0a2ab7ebf84ec2c05077ee68fc8e132c">DeclRefExprProc</a></div><div class="ttdeci">void DeclRefExprProc(bsoncxx::builder::basic::document &amp;MainNode, SubLevelProperties &amp;SubLvlPrp, BinaryOpProperties &amp;BinOpProp, const DeclRefExpr *DR, const SourceManager &amp;SourceManager)</div><div class="ttdef"><b>Definition:</b> DeclRefExprProc.h:547</div></div>
<div class="ttc" id="a_decl_ref_expr_proc_8h_html_ade8fb9ab0f90e12ab48ddb14d55de5ee"><div class="ttname"><a href="_decl_ref_expr_proc_8h.html#ade8fb9ab0f90e12ab48ddb14d55de5ee">ParenthesisExprProc</a></div><div class="ttdeci">void ParenthesisExprProc(bsoncxx::builder::basic::document &amp;MainNode, SubLevelProperties &amp;SubLvlPrp, const ParenExpr *PE, const SourceManager &amp;SourceManager, BinaryOpProperties &amp;BinOpProp)</div><div class="ttdef"><b>Definition:</b> DeclRefExprProc.h:729</div></div>
<div class="ttc" id="a_decl_ref_expr_proc_8h_html_ac4e74b9a8ec63c90b5b76b9bd385b2f9"><div class="ttname"><a href="_decl_ref_expr_proc_8h.html#ac4e74b9a8ec63c90b5b76b9bd385b2f9">FloatLiteralProc</a></div><div class="ttdeci">void FloatLiteralProc(bsoncxx::builder::basic::document &amp;MainNode, SubLevelProperties &amp;SubLvlPrp, BinaryOpProperties &amp;BinOpProp, const FloatingLiteral *FL, const SourceManager &amp;SourceManager)</div><div class="ttdef"><b>Definition:</b> DeclRefExprProc.h:673</div></div>
<div class="ttc" id="astruct_binary_op_properties_html"><div class="ttname"><a href="struct_binary_op_properties.html">BinaryOpProperties</a></div><div class="ttdef"><b>Definition:</b> TypesForAnalysis.h:561</div></div>
<div class="ttc" id="a_decl_ref_expr_proc_8h_html_a32c73a67da80dca716c3f23936948eb5"><div class="ttname"><a href="_decl_ref_expr_proc_8h.html#a32c73a67da80dca716c3f23936948eb5">SwitchStmtProc</a></div><div class="ttdeci">void SwitchStmtProc(bsoncxx::builder::basic::document &amp;MainNode, SubLevelProperties &amp;SubLvlPrp, BinaryOpProperties &amp;BinOpProp, const clang::SwitchStmt *SWTCHS, const SourceManager &amp;SourceManager)</div><div class="ttdef"><b>Definition:</b> DeclRefExprProc.h:877</div></div>
<div class="ttc" id="a_decl_ref_expr_proc_8h_html_a3ac3e261297050d743bc39b4f4f465e2"><div class="ttname"><a href="_decl_ref_expr_proc_8h.html#a3ac3e261297050d743bc39b4f4f465e2">WhileStmtProc</a></div><div class="ttdeci">void WhileStmtProc(bsoncxx::builder::basic::document &amp;MainNode, SubLevelProperties &amp;SubLvlPrp, BinaryOpProperties &amp;BinOpProp, const clang::WhileStmt *WHLS, const SourceManager &amp;SourceManager)</div><div class="ttdef"><b>Definition:</b> DeclRefExprProc.h:801</div></div>
<div class="ttc" id="a_decl_ref_expr_proc_8h_html_a9c91ca84f5245f7e0359cda6c2b893d7"><div class="ttname"><a href="_decl_ref_expr_proc_8h.html#a9c91ca84f5245f7e0359cda6c2b893d7">MemberExprProc</a></div><div class="ttdeci">void MemberExprProc(bsoncxx::builder::basic::document &amp;MainNode, SubLevelProperties &amp;SubLvlPrp, BinaryOpProperties &amp;BinOpProp, const MemberExpr *ME, const SourceManager &amp;SourceManager)</div><div class="ttdef"><b>Definition:</b> DeclRefExprProc.h:752</div></div>
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="_stmt_proc_dispatcher_8h.html">StmtProcDispatcher.h</a></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.17 </li>
  </ul>
</div>
</body>
</html>
